const std = @import("std");
const serializeMap = @import("json.zig").serializeMap;
const smithy = @import("smithy");

const Self = @This();
pub const version: []const u8 = "2017-11-27";
pub const sdk_id: []const u8 = "Comprehend";
pub const arn_namespace: []const u8 = "comprehend";
pub const endpoint_prefix: []const u8 = "comprehend";
pub const sigv4_name: []const u8 = "comprehend";
pub const name: []const u8 = "Comprehend_20171127";
pub const aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1;

pub const service_metadata: struct {
    version: []const u8 = "2017-11-27",
    sdk_id: []const u8 = "Comprehend",
    arn_namespace: []const u8 = "comprehend",
    endpoint_prefix: []const u8 = "comprehend",
    sigv4_name: []const u8 = "comprehend",
    name: []const u8 = "Comprehend_20171127",
    aws_protocol: smithy.AwsProtocol = smithy.AwsProtocol.json_1_1,
} = .{};
pub const batch_detect_dominant_language: struct {
    action_name: []const u8 = "BatchDetectDominantLanguage",
    Request: type = struct {
        text_list: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text_list = "TextList",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_detect_dominant_language) } {
            return .{ .service_metadata = service_metadata, .action = batch_detect_dominant_language };
        }
    },
    Response: type = struct {
        result_list: []struct {
            index: ?i64 = null,
            languages: ?[]DominantLanguage = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .index = "Index",
                    .languages = "Languages",
                };
                return @field(mappings, field_name);
            }
        },
        error_list: []BatchItemError,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .result_list = "ResultList",
                .error_list = "ErrorList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BatchSizeLimitExceeded,
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
    },
} = .{};
pub const batch_detect_entities: struct {
    action_name: []const u8 = "BatchDetectEntities",
    Request: type = struct {
        text_list: [][]const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text_list = "TextList",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_detect_entities) } {
            return .{ .service_metadata = service_metadata, .action = batch_detect_entities };
        }
    },
    Response: type = struct {
        result_list: []struct {
            index: ?i64 = null,
            entities: ?[]Entity = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .index = "Index",
                    .entities = "Entities",
                };
                return @field(mappings, field_name);
            }
        },
        error_list: []BatchItemError,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .result_list = "ResultList",
                .error_list = "ErrorList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BatchSizeLimitExceeded,
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const batch_detect_key_phrases: struct {
    action_name: []const u8 = "BatchDetectKeyPhrases",
    Request: type = struct {
        text_list: [][]const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text_list = "TextList",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_detect_key_phrases) } {
            return .{ .service_metadata = service_metadata, .action = batch_detect_key_phrases };
        }
    },
    Response: type = struct {
        result_list: []struct {
            index: ?i64 = null,
            key_phrases: ?[]KeyPhrase = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .index = "Index",
                    .key_phrases = "KeyPhrases",
                };
                return @field(mappings, field_name);
            }
        },
        error_list: []BatchItemError,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .result_list = "ResultList",
                .error_list = "ErrorList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BatchSizeLimitExceeded,
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const batch_detect_sentiment: struct {
    action_name: []const u8 = "BatchDetectSentiment",
    Request: type = struct {
        text_list: [][]const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text_list = "TextList",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_detect_sentiment) } {
            return .{ .service_metadata = service_metadata, .action = batch_detect_sentiment };
        }
    },
    Response: type = struct {
        result_list: []struct {
            index: ?i64 = null,
            sentiment: ?[]const u8 = null,
            sentiment_score: ?SentimentScore = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .index = "Index",
                    .sentiment = "Sentiment",
                    .sentiment_score = "SentimentScore",
                };
                return @field(mappings, field_name);
            }
        },
        error_list: []BatchItemError,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .result_list = "ResultList",
                .error_list = "ErrorList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BatchSizeLimitExceeded,
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const batch_detect_syntax: struct {
    action_name: []const u8 = "BatchDetectSyntax",
    Request: type = struct {
        text_list: [][]const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text_list = "TextList",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(batch_detect_syntax) } {
            return .{ .service_metadata = service_metadata, .action = batch_detect_syntax };
        }
    },
    Response: type = struct {
        result_list: []struct {
            index: ?i64 = null,
            syntax_tokens: ?[]SyntaxToken = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .index = "Index",
                    .syntax_tokens = "SyntaxTokens",
                };
                return @field(mappings, field_name);
            }
        },
        error_list: []BatchItemError,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .result_list = "ResultList",
                .error_list = "ErrorList",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        BatchSizeLimitExceeded,
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const classify_document: struct {
    action_name: []const u8 = "ClassifyDocument",
    Request: type = struct {
        text: []const u8,
        endpoint_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .endpoint_arn = "EndpointArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(classify_document) } {
            return .{ .service_metadata = service_metadata, .action = classify_document };
        }
    },
    Response: type = struct {
        classes: ?[]struct {
            name: ?[]const u8 = null,
            score: ?f32 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .score = "Score",
                };
                return @field(mappings, field_name);
            }
        } = null,
        labels: ?[]struct {
            name: ?[]const u8 = null,
            score: ?f32 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .score = "Score",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .classes = "Classes",
                .labels = "Labels",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceUnavailable,
        TextSizeLimitExceeded,
    },
} = .{};
pub const contains_pii_entities: struct {
    action_name: []const u8 = "ContainsPiiEntities",
    Request: type = struct {
        text: []const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(contains_pii_entities) } {
            return .{ .service_metadata = service_metadata, .action = contains_pii_entities };
        }
    },
    Response: type = struct {
        labels: ?[]struct {
            name: ?[]const u8 = null,
            score: ?f32 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .name = "Name",
                    .score = "Score",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .labels = "Labels",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const create_document_classifier: struct {
    action_name: []const u8 = "CreateDocumentClassifier",
    Request: type = struct {
        document_classifier_name: []const u8,
        data_access_role_arn: []const u8,
        tags: ?[]Tag = null,
        input_data_config: DocumentClassifierInputDataConfig,
        output_data_config: ?DocumentClassifierOutputDataConfig = null,
        client_request_token: ?[]const u8 = null,
        language_code: []const u8,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,
        mode: ?[]const u8 = null,
        model_kms_key_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_name = "DocumentClassifierName",
                .data_access_role_arn = "DataAccessRoleArn",
                .tags = "Tags",
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .client_request_token = "ClientRequestToken",
                .language_code = "LanguageCode",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
                .mode = "Mode",
                .model_kms_key_id = "ModelKmsKeyId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_document_classifier) } {
            return .{ .service_metadata = service_metadata, .action = create_document_classifier };
        }
    },
    Response: type = struct {
        document_classifier_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_arn = "DocumentClassifierArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        ResourceLimitExceeded,
        TooManyRequests,
        TooManyTags,
        UnsupportedLanguage,
    },
} = .{};
pub const create_endpoint: struct {
    action_name: []const u8 = "CreateEndpoint",
    Request: type = struct {
        endpoint_name: []const u8,
        model_arn: []const u8,
        desired_inference_units: i64,
        client_request_token: ?[]const u8 = null,
        tags: ?[]Tag = null,
        data_access_role_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .endpoint_name = "EndpointName",
                .model_arn = "ModelArn",
                .desired_inference_units = "DesiredInferenceUnits",
                .client_request_token = "ClientRequestToken",
                .tags = "Tags",
                .data_access_role_arn = "DataAccessRoleArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_endpoint) } {
            return .{ .service_metadata = service_metadata, .action = create_endpoint };
        }
    },
    Response: type = struct {
        endpoint_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .endpoint_arn = "EndpointArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceInUse,
        ResourceLimitExceeded,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
        TooManyTags,
    },
} = .{};
pub const create_entity_recognizer: struct {
    action_name: []const u8 = "CreateEntityRecognizer",
    Request: type = struct {
        recognizer_name: []const u8,
        data_access_role_arn: []const u8,
        tags: ?[]Tag = null,
        input_data_config: EntityRecognizerInputDataConfig,
        client_request_token: ?[]const u8 = null,
        language_code: []const u8,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,
        model_kms_key_id: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .recognizer_name = "RecognizerName",
                .data_access_role_arn = "DataAccessRoleArn",
                .tags = "Tags",
                .input_data_config = "InputDataConfig",
                .client_request_token = "ClientRequestToken",
                .language_code = "LanguageCode",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
                .model_kms_key_id = "ModelKmsKeyId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(create_entity_recognizer) } {
            return .{ .service_metadata = service_metadata, .action = create_entity_recognizer };
        }
    },
    Response: type = struct {
        entity_recognizer_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_recognizer_arn = "EntityRecognizerArn",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceInUse,
        ResourceLimitExceeded,
        TooManyRequests,
        TooManyTags,
        UnsupportedLanguage,
    },
} = .{};
pub const delete_document_classifier: struct {
    action_name: []const u8 = "DeleteDocumentClassifier",
    Request: type = struct {
        document_classifier_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_arn = "DocumentClassifierArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_document_classifier) } {
            return .{ .service_metadata = service_metadata, .action = delete_document_classifier };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
    },
} = .{};
pub const delete_endpoint: struct {
    action_name: []const u8 = "DeleteEndpoint",
    Request: type = struct {
        endpoint_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .endpoint_arn = "EndpointArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_endpoint) } {
            return .{ .service_metadata = service_metadata, .action = delete_endpoint };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const delete_entity_recognizer: struct {
    action_name: []const u8 = "DeleteEntityRecognizer",
    Request: type = struct {
        entity_recognizer_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_recognizer_arn = "EntityRecognizerArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(delete_entity_recognizer) } {
            return .{ .service_metadata = service_metadata, .action = delete_entity_recognizer };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceInUse,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
    },
} = .{};
pub const describe_document_classification_job: struct {
    action_name: []const u8 = "DescribeDocumentClassificationJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_document_classification_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_document_classification_job };
        }
    },
    Response: type = struct {
        document_classification_job_properties: ?DocumentClassificationJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classification_job_properties = "DocumentClassificationJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_document_classifier: struct {
    action_name: []const u8 = "DescribeDocumentClassifier",
    Request: type = struct {
        document_classifier_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_arn = "DocumentClassifierArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_document_classifier) } {
            return .{ .service_metadata = service_metadata, .action = describe_document_classifier };
        }
    },
    Response: type = struct {
        document_classifier_properties: ?DocumentClassifierProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_properties = "DocumentClassifierProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_dominant_language_detection_job: struct {
    action_name: []const u8 = "DescribeDominantLanguageDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_dominant_language_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_dominant_language_detection_job };
        }
    },
    Response: type = struct {
        dominant_language_detection_job_properties: ?DominantLanguageDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dominant_language_detection_job_properties = "DominantLanguageDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_endpoint: struct {
    action_name: []const u8 = "DescribeEndpoint",
    Request: type = struct {
        endpoint_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .endpoint_arn = "EndpointArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_endpoint) } {
            return .{ .service_metadata = service_metadata, .action = describe_endpoint };
        }
    },
    Response: type = struct {
        endpoint_properties: ?EndpointProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .endpoint_properties = "EndpointProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_entities_detection_job: struct {
    action_name: []const u8 = "DescribeEntitiesDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_entities_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_entities_detection_job };
        }
    },
    Response: type = struct {
        entities_detection_job_properties: ?EntitiesDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities_detection_job_properties = "EntitiesDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_entity_recognizer: struct {
    action_name: []const u8 = "DescribeEntityRecognizer",
    Request: type = struct {
        entity_recognizer_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_recognizer_arn = "EntityRecognizerArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_entity_recognizer) } {
            return .{ .service_metadata = service_metadata, .action = describe_entity_recognizer };
        }
    },
    Response: type = struct {
        entity_recognizer_properties: ?EntityRecognizerProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_recognizer_properties = "EntityRecognizerProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_events_detection_job: struct {
    action_name: []const u8 = "DescribeEventsDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_events_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_events_detection_job };
        }
    },
    Response: type = struct {
        events_detection_job_properties: ?EventsDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .events_detection_job_properties = "EventsDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_key_phrases_detection_job: struct {
    action_name: []const u8 = "DescribeKeyPhrasesDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_key_phrases_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_key_phrases_detection_job };
        }
    },
    Response: type = struct {
        key_phrases_detection_job_properties: ?KeyPhrasesDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .key_phrases_detection_job_properties = "KeyPhrasesDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_pii_entities_detection_job: struct {
    action_name: []const u8 = "DescribePiiEntitiesDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_pii_entities_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_pii_entities_detection_job };
        }
    },
    Response: type = struct {
        pii_entities_detection_job_properties: ?PiiEntitiesDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .pii_entities_detection_job_properties = "PiiEntitiesDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_sentiment_detection_job: struct {
    action_name: []const u8 = "DescribeSentimentDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_sentiment_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_sentiment_detection_job };
        }
    },
    Response: type = struct {
        sentiment_detection_job_properties: ?SentimentDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sentiment_detection_job_properties = "SentimentDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const describe_topics_detection_job: struct {
    action_name: []const u8 = "DescribeTopicsDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(describe_topics_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = describe_topics_detection_job };
        }
    },
    Response: type = struct {
        topics_detection_job_properties: ?TopicsDetectionJobProperties = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .topics_detection_job_properties = "TopicsDetectionJobProperties",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
        TooManyRequests,
    },
} = .{};
pub const detect_dominant_language: struct {
    action_name: []const u8 = "DetectDominantLanguage",
    Request: type = struct {
        text: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_dominant_language) } {
            return .{ .service_metadata = service_metadata, .action = detect_dominant_language };
        }
    },
    Response: type = struct {
        languages: ?[]DominantLanguage = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .languages = "Languages",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
    },
} = .{};
pub const detect_entities: struct {
    action_name: []const u8 = "DetectEntities",
    Request: type = struct {
        text: []const u8,
        language_code: ?[]const u8 = null,
        endpoint_arn: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .language_code = "LanguageCode",
                .endpoint_arn = "EndpointArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_entities) } {
            return .{ .service_metadata = service_metadata, .action = detect_entities };
        }
    },
    Response: type = struct {
        entities: ?[]Entity = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities = "Entities",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceUnavailable,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const detect_key_phrases: struct {
    action_name: []const u8 = "DetectKeyPhrases",
    Request: type = struct {
        text: []const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_key_phrases) } {
            return .{ .service_metadata = service_metadata, .action = detect_key_phrases };
        }
    },
    Response: type = struct {
        key_phrases: ?[]KeyPhrase = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .key_phrases = "KeyPhrases",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const detect_pii_entities: struct {
    action_name: []const u8 = "DetectPiiEntities",
    Request: type = struct {
        text: []const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_pii_entities) } {
            return .{ .service_metadata = service_metadata, .action = detect_pii_entities };
        }
    },
    Response: type = struct {
        entities: ?[]struct {
            score: ?f32 = null,
            type: ?[]const u8 = null,
            begin_offset: ?i64 = null,
            end_offset: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .score = "Score",
                    .type = "Type",
                    .begin_offset = "BeginOffset",
                    .end_offset = "EndOffset",
                };
                return @field(mappings, field_name);
            }
        } = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities = "Entities",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const detect_sentiment: struct {
    action_name: []const u8 = "DetectSentiment",
    Request: type = struct {
        text: []const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_sentiment) } {
            return .{ .service_metadata = service_metadata, .action = detect_sentiment };
        }
    },
    Response: type = struct {
        sentiment: ?[]const u8 = null,
        sentiment_score: ?SentimentScore = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sentiment = "Sentiment",
                .sentiment_score = "SentimentScore",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const detect_syntax: struct {
    action_name: []const u8 = "DetectSyntax",
    Request: type = struct {
        text: []const u8,
        language_code: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .text = "Text",
                .language_code = "LanguageCode",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(detect_syntax) } {
            return .{ .service_metadata = service_metadata, .action = detect_syntax };
        }
    },
    Response: type = struct {
        syntax_tokens: ?[]SyntaxToken = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .syntax_tokens = "SyntaxTokens",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TextSizeLimitExceeded,
        UnsupportedLanguage,
    },
} = .{};
pub const list_document_classification_jobs: struct {
    action_name: []const u8 = "ListDocumentClassificationJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_document_classification_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_document_classification_jobs };
        }
    },
    Response: type = struct {
        document_classification_job_properties_list: ?[]DocumentClassificationJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classification_job_properties_list = "DocumentClassificationJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_document_classifiers: struct {
    action_name: []const u8 = "ListDocumentClassifiers",
    Request: type = struct {
        filter: ?struct {
            status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .status = "Status",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_document_classifiers) } {
            return .{ .service_metadata = service_metadata, .action = list_document_classifiers };
        }
    },
    Response: type = struct {
        document_classifier_properties_list: ?[]DocumentClassifierProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_properties_list = "DocumentClassifierPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_dominant_language_detection_jobs: struct {
    action_name: []const u8 = "ListDominantLanguageDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_dominant_language_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_dominant_language_detection_jobs };
        }
    },
    Response: type = struct {
        dominant_language_detection_job_properties_list: ?[]DominantLanguageDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .dominant_language_detection_job_properties_list = "DominantLanguageDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_endpoints: struct {
    action_name: []const u8 = "ListEndpoints",
    Request: type = struct {
        filter: ?struct {
            model_arn: ?[]const u8 = null,
            status: ?[]const u8 = null,
            creation_time_before: ?i64 = null,
            creation_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .model_arn = "ModelArn",
                    .status = "Status",
                    .creation_time_before = "CreationTimeBefore",
                    .creation_time_after = "CreationTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_endpoints) } {
            return .{ .service_metadata = service_metadata, .action = list_endpoints };
        }
    },
    Response: type = struct {
        endpoint_properties_list: ?[]EndpointProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .endpoint_properties_list = "EndpointPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_entities_detection_jobs: struct {
    action_name: []const u8 = "ListEntitiesDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_entities_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_entities_detection_jobs };
        }
    },
    Response: type = struct {
        entities_detection_job_properties_list: ?[]EntitiesDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entities_detection_job_properties_list = "EntitiesDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_entity_recognizers: struct {
    action_name: []const u8 = "ListEntityRecognizers",
    Request: type = struct {
        filter: ?struct {
            status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .status = "Status",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_entity_recognizers) } {
            return .{ .service_metadata = service_metadata, .action = list_entity_recognizers };
        }
    },
    Response: type = struct {
        entity_recognizer_properties_list: ?[]EntityRecognizerProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_recognizer_properties_list = "EntityRecognizerPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_events_detection_jobs: struct {
    action_name: []const u8 = "ListEventsDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_events_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_events_detection_jobs };
        }
    },
    Response: type = struct {
        events_detection_job_properties_list: ?[]EventsDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .events_detection_job_properties_list = "EventsDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_key_phrases_detection_jobs: struct {
    action_name: []const u8 = "ListKeyPhrasesDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_key_phrases_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_key_phrases_detection_jobs };
        }
    },
    Response: type = struct {
        key_phrases_detection_job_properties_list: ?[]KeyPhrasesDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .key_phrases_detection_job_properties_list = "KeyPhrasesDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_pii_entities_detection_jobs: struct {
    action_name: []const u8 = "ListPiiEntitiesDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_pii_entities_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_pii_entities_detection_jobs };
        }
    },
    Response: type = struct {
        pii_entities_detection_job_properties_list: ?[]PiiEntitiesDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .pii_entities_detection_job_properties_list = "PiiEntitiesDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_sentiment_detection_jobs: struct {
    action_name: []const u8 = "ListSentimentDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_sentiment_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_sentiment_detection_jobs };
        }
    },
    Response: type = struct {
        sentiment_detection_job_properties_list: ?[]SentimentDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .sentiment_detection_job_properties_list = "SentimentDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const list_tags_for_resource: struct {
    action_name: []const u8 = "ListTagsForResource",
    Request: type = struct {
        resource_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_tags_for_resource) } {
            return .{ .service_metadata = service_metadata, .action = list_tags_for_resource };
        }
    },
    Response: type = struct {
        resource_arn: ?[]const u8 = null,
        tags: ?[]Tag = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
    },
} = .{};
pub const list_topics_detection_jobs: struct {
    action_name: []const u8 = "ListTopicsDetectionJobs",
    Request: type = struct {
        filter: ?struct {
            job_name: ?[]const u8 = null,
            job_status: ?[]const u8 = null,
            submit_time_before: ?i64 = null,
            submit_time_after: ?i64 = null,

            pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
                const mappings = .{
                    .job_name = "JobName",
                    .job_status = "JobStatus",
                    .submit_time_before = "SubmitTimeBefore",
                    .submit_time_after = "SubmitTimeAfter",
                };
                return @field(mappings, field_name);
            }
        } = null,
        next_token: ?[]const u8 = null,
        max_results: ?i64 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .filter = "Filter",
                .next_token = "NextToken",
                .max_results = "MaxResults",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(list_topics_detection_jobs) } {
            return .{ .service_metadata = service_metadata, .action = list_topics_detection_jobs };
        }
    },
    Response: type = struct {
        topics_detection_job_properties_list: ?[]TopicsDetectionJobProperties = null,
        next_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .topics_detection_job_properties_list = "TopicsDetectionJobPropertiesList",
                .next_token = "NextToken",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidFilter,
        InvalidRequest,
        TooManyRequests,
    },
} = .{};
pub const start_document_classification_job: struct {
    action_name: []const u8 = "StartDocumentClassificationJob",
    Request: type = struct {
        job_name: ?[]const u8 = null,
        document_classifier_arn: []const u8,
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        client_request_token: ?[]const u8 = null,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_name = "JobName",
                .document_classifier_arn = "DocumentClassifierArn",
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .client_request_token = "ClientRequestToken",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_document_classification_job) } {
            return .{ .service_metadata = service_metadata, .action = start_document_classification_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
    },
} = .{};
pub const start_dominant_language_detection_job: struct {
    action_name: []const u8 = "StartDominantLanguageDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        client_request_token: ?[]const u8 = null,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .client_request_token = "ClientRequestToken",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_dominant_language_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_dominant_language_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        TooManyRequests,
    },
} = .{};
pub const start_entities_detection_job: struct {
    action_name: []const u8 = "StartEntitiesDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        entity_recognizer_arn: ?[]const u8 = null,
        language_code: []const u8,
        client_request_token: ?[]const u8 = null,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .entity_recognizer_arn = "EntityRecognizerArn",
                .language_code = "LanguageCode",
                .client_request_token = "ClientRequestToken",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_entities_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_entities_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
    },
} = .{};
pub const start_events_detection_job: struct {
    action_name: []const u8 = "StartEventsDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        language_code: []const u8,
        client_request_token: ?[]const u8 = null,
        target_event_types: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .language_code = "LanguageCode",
                .client_request_token = "ClientRequestToken",
                .target_event_types = "TargetEventTypes",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_events_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_events_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        TooManyRequests,
    },
} = .{};
pub const start_key_phrases_detection_job: struct {
    action_name: []const u8 = "StartKeyPhrasesDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        language_code: []const u8,
        client_request_token: ?[]const u8 = null,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .language_code = "LanguageCode",
                .client_request_token = "ClientRequestToken",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_key_phrases_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_key_phrases_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        TooManyRequests,
    },
} = .{};
pub const start_pii_entities_detection_job: struct {
    action_name: []const u8 = "StartPiiEntitiesDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        mode: []const u8,
        redaction_config: ?RedactionConfig = null,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        language_code: []const u8,
        client_request_token: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .mode = "Mode",
                .redaction_config = "RedactionConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .language_code = "LanguageCode",
                .client_request_token = "ClientRequestToken",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_pii_entities_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_pii_entities_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        TooManyRequests,
    },
} = .{};
pub const start_sentiment_detection_job: struct {
    action_name: []const u8 = "StartSentimentDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        language_code: []const u8,
        client_request_token: ?[]const u8 = null,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .language_code = "LanguageCode",
                .client_request_token = "ClientRequestToken",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_sentiment_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_sentiment_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        TooManyRequests,
    },
} = .{};
pub const start_topics_detection_job: struct {
    action_name: []const u8 = "StartTopicsDetectionJob",
    Request: type = struct {
        input_data_config: InputDataConfig,
        output_data_config: OutputDataConfig,
        data_access_role_arn: []const u8,
        job_name: ?[]const u8 = null,
        number_of_topics: ?i64 = null,
        client_request_token: ?[]const u8 = null,
        volume_kms_key_id: ?[]const u8 = null,
        vpc_config: ?VpcConfig = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .input_data_config = "InputDataConfig",
                .output_data_config = "OutputDataConfig",
                .data_access_role_arn = "DataAccessRoleArn",
                .job_name = "JobName",
                .number_of_topics = "NumberOfTopics",
                .client_request_token = "ClientRequestToken",
                .volume_kms_key_id = "VolumeKmsKeyId",
                .vpc_config = "VpcConfig",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(start_topics_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = start_topics_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        KmsKeyValidation,
        TooManyRequests,
    },
} = .{};
pub const stop_dominant_language_detection_job: struct {
    action_name: []const u8 = "StopDominantLanguageDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_dominant_language_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_dominant_language_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
    },
} = .{};
pub const stop_entities_detection_job: struct {
    action_name: []const u8 = "StopEntitiesDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_entities_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_entities_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
    },
} = .{};
pub const stop_events_detection_job: struct {
    action_name: []const u8 = "StopEventsDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_events_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_events_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
    },
} = .{};
pub const stop_key_phrases_detection_job: struct {
    action_name: []const u8 = "StopKeyPhrasesDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_key_phrases_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_key_phrases_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
    },
} = .{};
pub const stop_pii_entities_detection_job: struct {
    action_name: []const u8 = "StopPiiEntitiesDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_pii_entities_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_pii_entities_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
    },
} = .{};
pub const stop_sentiment_detection_job: struct {
    action_name: []const u8 = "StopSentimentDetectionJob",
    Request: type = struct {
        job_id: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_sentiment_detection_job) } {
            return .{ .service_metadata = service_metadata, .action = stop_sentiment_detection_job };
        }
    },
    Response: type = struct {
        job_id: ?[]const u8 = null,
        job_status: ?[]const u8 = null,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .job_id = "JobId",
                .job_status = "JobStatus",
            };
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        JobNotFound,
    },
} = .{};
pub const stop_training_document_classifier: struct {
    action_name: []const u8 = "StopTrainingDocumentClassifier",
    Request: type = struct {
        document_classifier_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .document_classifier_arn = "DocumentClassifierArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_training_document_classifier) } {
            return .{ .service_metadata = service_metadata, .action = stop_training_document_classifier };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const stop_training_entity_recognizer: struct {
    action_name: []const u8 = "StopTrainingEntityRecognizer",
    Request: type = struct {
        entity_recognizer_arn: []const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .entity_recognizer_arn = "EntityRecognizerArn",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(stop_training_entity_recognizer) } {
            return .{ .service_metadata = service_metadata, .action = stop_training_entity_recognizer };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyRequests,
    },
} = .{};
pub const tag_resource: struct {
    action_name: []const u8 = "TagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tags: []Tag,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tags = "Tags",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(tag_resource) } {
            return .{ .service_metadata = service_metadata, .action = tag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyTags,
    },
} = .{};
pub const untag_resource: struct {
    action_name: []const u8 = "UntagResource",
    Request: type = struct {
        resource_arn: []const u8,
        tag_keys: [][]const u8,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .resource_arn = "ResourceArn",
                .tag_keys = "TagKeys",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(untag_resource) } {
            return .{ .service_metadata = service_metadata, .action = untag_resource };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        ConcurrentModification,
        InternalServer,
        InvalidRequest,
        ResourceNotFound,
        TooManyTagKeys,
    },
} = .{};
pub const update_endpoint: struct {
    action_name: []const u8 = "UpdateEndpoint",
    Request: type = struct {
        endpoint_arn: []const u8,
        desired_inference_units: i64,

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{
                .endpoint_arn = "EndpointArn",
                .desired_inference_units = "DesiredInferenceUnits",
            };
            return @field(mappings, field_name);
        }

        pub fn metaInfo() struct { service_metadata: @TypeOf(service_metadata), action: @TypeOf(update_endpoint) } {
            return .{ .service_metadata = service_metadata, .action = update_endpoint };
        }
    },
    Response: type = struct {

        pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
            const mappings = .{};
            return @field(mappings, field_name);
        }
    },
    ServiceError: type = error{
        InternalServer,
        InvalidRequest,
        ResourceInUse,
        ResourceLimitExceeded,
        ResourceNotFound,
        ResourceUnavailable,
        TooManyRequests,
    },
} = .{};

pub const Tag = struct {
    key: []const u8,
    value: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .key = "Key",
            .value = "Value",
        };
        return @field(mappings, field_name);
    }
};

pub const VpcConfig = struct {
    security_group_ids: [][]const u8,
    subnets: [][]const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .security_group_ids = "SecurityGroupIds",
            .subnets = "Subnets",
        };
        return @field(mappings, field_name);
    }
};

pub const OutputDataConfig = struct {
    s3_uri: []const u8,
    kms_key_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .kms_key_id = "KmsKeyId",
        };
        return @field(mappings, field_name);
    }
};

pub const InputDataConfig = struct {
    s3_uri: []const u8,
    input_format: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .input_format = "InputFormat",
        };
        return @field(mappings, field_name);
    }
};

pub const RedactionConfig = struct {
    pii_entity_types: ?[][]const u8 = null,
    mask_mode: ?[]const u8 = null,
    mask_character: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .pii_entity_types = "PiiEntityTypes",
            .mask_mode = "MaskMode",
            .mask_character = "MaskCharacter",
        };
        return @field(mappings, field_name);
    }
};

pub const TopicsDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    number_of_topics: ?i64 = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .number_of_topics = "NumberOfTopics",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const SentimentDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    language_code: ?[]const u8 = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .language_code = "LanguageCode",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const PiiEntitiesDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?PiiOutputDataConfig = null,
    redaction_config: ?RedactionConfig = null,
    language_code: ?[]const u8 = null,
    data_access_role_arn: ?[]const u8 = null,
    mode: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .redaction_config = "RedactionConfig",
            .language_code = "LanguageCode",
            .data_access_role_arn = "DataAccessRoleArn",
            .mode = "Mode",
        };
        return @field(mappings, field_name);
    }
};

pub const PiiOutputDataConfig = struct {
    s3_uri: []const u8,
    kms_key_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .kms_key_id = "KmsKeyId",
        };
        return @field(mappings, field_name);
    }
};

pub const KeyPhrasesDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    language_code: ?[]const u8 = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .language_code = "LanguageCode",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const EventsDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    language_code: ?[]const u8 = null,
    data_access_role_arn: ?[]const u8 = null,
    target_event_types: ?[][]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .language_code = "LanguageCode",
            .data_access_role_arn = "DataAccessRoleArn",
            .target_event_types = "TargetEventTypes",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerProperties = struct {
    entity_recognizer_arn: ?[]const u8 = null,
    language_code: ?[]const u8 = null,
    status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    training_start_time: ?i64 = null,
    training_end_time: ?i64 = null,
    input_data_config: ?EntityRecognizerInputDataConfig = null,
    recognizer_metadata: ?EntityRecognizerMetadata = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,
    model_kms_key_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .entity_recognizer_arn = "EntityRecognizerArn",
            .language_code = "LanguageCode",
            .status = "Status",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .training_start_time = "TrainingStartTime",
            .training_end_time = "TrainingEndTime",
            .input_data_config = "InputDataConfig",
            .recognizer_metadata = "RecognizerMetadata",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
            .model_kms_key_id = "ModelKmsKeyId",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerMetadata = struct {
    number_of_trained_documents: ?i64 = null,
    number_of_test_documents: ?i64 = null,
    evaluation_metrics: ?EntityRecognizerEvaluationMetrics = null,
    entity_types: ?[]EntityRecognizerMetadataEntityTypesListItem = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .number_of_trained_documents = "NumberOfTrainedDocuments",
            .number_of_test_documents = "NumberOfTestDocuments",
            .evaluation_metrics = "EvaluationMetrics",
            .entity_types = "EntityTypes",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerMetadataEntityTypesListItem = struct {
    type: ?[]const u8 = null,
    evaluation_metrics: ?EntityTypesEvaluationMetrics = null,
    number_of_train_mentions: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "Type",
            .evaluation_metrics = "EvaluationMetrics",
            .number_of_train_mentions = "NumberOfTrainMentions",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityTypesEvaluationMetrics = struct {
    precision: ?f64 = null,
    recall: ?f64 = null,
    f1_score: ?f64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .precision = "Precision",
            .recall = "Recall",
            .f1_score = "F1Score",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerEvaluationMetrics = struct {
    precision: ?f64 = null,
    recall: ?f64 = null,
    f1_score: ?f64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .precision = "Precision",
            .recall = "Recall",
            .f1_score = "F1Score",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerInputDataConfig = struct {
    data_format: ?[]const u8 = null,
    entity_types: []EntityTypesListItem,
    documents: ?EntityRecognizerDocuments = null,
    annotations: ?EntityRecognizerAnnotations = null,
    entity_list: ?EntityRecognizerEntityList = null,
    augmented_manifests: ?[]AugmentedManifestsListItem = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .data_format = "DataFormat",
            .entity_types = "EntityTypes",
            .documents = "Documents",
            .annotations = "Annotations",
            .entity_list = "EntityList",
            .augmented_manifests = "AugmentedManifests",
        };
        return @field(mappings, field_name);
    }
};

pub const AugmentedManifestsListItem = struct {
    s3_uri: []const u8,
    attribute_names: [][]const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .attribute_names = "AttributeNames",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerEntityList = struct {
    s3_uri: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerAnnotations = struct {
    s3_uri: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityRecognizerDocuments = struct {
    s3_uri: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
        };
        return @field(mappings, field_name);
    }
};

pub const EntityTypesListItem = struct {
    type: []const u8,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .type = "Type",
        };
        return @field(mappings, field_name);
    }
};

pub const EntitiesDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    entity_recognizer_arn: ?[]const u8 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    language_code: ?[]const u8 = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .entity_recognizer_arn = "EntityRecognizerArn",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .language_code = "LanguageCode",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const EndpointProperties = struct {
    endpoint_arn: ?[]const u8 = null,
    status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    model_arn: ?[]const u8 = null,
    desired_inference_units: ?i64 = null,
    current_inference_units: ?i64 = null,
    creation_time: ?i64 = null,
    last_modified_time: ?i64 = null,
    data_access_role_arn: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .endpoint_arn = "EndpointArn",
            .status = "Status",
            .message = "Message",
            .model_arn = "ModelArn",
            .desired_inference_units = "DesiredInferenceUnits",
            .current_inference_units = "CurrentInferenceUnits",
            .creation_time = "CreationTime",
            .last_modified_time = "LastModifiedTime",
            .data_access_role_arn = "DataAccessRoleArn",
        };
        return @field(mappings, field_name);
    }
};

pub const DominantLanguageDetectionJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentClassifierProperties = struct {
    document_classifier_arn: ?[]const u8 = null,
    language_code: ?[]const u8 = null,
    status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    training_start_time: ?i64 = null,
    training_end_time: ?i64 = null,
    input_data_config: ?DocumentClassifierInputDataConfig = null,
    output_data_config: ?DocumentClassifierOutputDataConfig = null,
    classifier_metadata: ?ClassifierMetadata = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,
    mode: ?[]const u8 = null,
    model_kms_key_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .document_classifier_arn = "DocumentClassifierArn",
            .language_code = "LanguageCode",
            .status = "Status",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .training_start_time = "TrainingStartTime",
            .training_end_time = "TrainingEndTime",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .classifier_metadata = "ClassifierMetadata",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
            .mode = "Mode",
            .model_kms_key_id = "ModelKmsKeyId",
        };
        return @field(mappings, field_name);
    }
};

pub const ClassifierMetadata = struct {
    number_of_labels: ?i64 = null,
    number_of_trained_documents: ?i64 = null,
    number_of_test_documents: ?i64 = null,
    evaluation_metrics: ?ClassifierEvaluationMetrics = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .number_of_labels = "NumberOfLabels",
            .number_of_trained_documents = "NumberOfTrainedDocuments",
            .number_of_test_documents = "NumberOfTestDocuments",
            .evaluation_metrics = "EvaluationMetrics",
        };
        return @field(mappings, field_name);
    }
};

pub const ClassifierEvaluationMetrics = struct {
    accuracy: ?f64 = null,
    precision: ?f64 = null,
    recall: ?f64 = null,
    f1_score: ?f64 = null,
    micro_precision: ?f64 = null,
    micro_recall: ?f64 = null,
    micro_f1_score: ?f64 = null,
    hamming_loss: ?f64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .accuracy = "Accuracy",
            .precision = "Precision",
            .recall = "Recall",
            .f1_score = "F1Score",
            .micro_precision = "MicroPrecision",
            .micro_recall = "MicroRecall",
            .micro_f1_score = "MicroF1Score",
            .hamming_loss = "HammingLoss",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentClassifierOutputDataConfig = struct {
    s3_uri: ?[]const u8 = null,
    kms_key_id: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .s3_uri = "S3Uri",
            .kms_key_id = "KmsKeyId",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentClassifierInputDataConfig = struct {
    data_format: ?[]const u8 = null,
    s3_uri: ?[]const u8 = null,
    label_delimiter: ?[]const u8 = null,
    augmented_manifests: ?[]AugmentedManifestsListItem = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .data_format = "DataFormat",
            .s3_uri = "S3Uri",
            .label_delimiter = "LabelDelimiter",
            .augmented_manifests = "AugmentedManifests",
        };
        return @field(mappings, field_name);
    }
};

pub const DocumentClassificationJobProperties = struct {
    job_id: ?[]const u8 = null,
    job_name: ?[]const u8 = null,
    job_status: ?[]const u8 = null,
    message: ?[]const u8 = null,
    submit_time: ?i64 = null,
    end_time: ?i64 = null,
    document_classifier_arn: ?[]const u8 = null,
    input_data_config: ?InputDataConfig = null,
    output_data_config: ?OutputDataConfig = null,
    data_access_role_arn: ?[]const u8 = null,
    volume_kms_key_id: ?[]const u8 = null,
    vpc_config: ?VpcConfig = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .job_id = "JobId",
            .job_name = "JobName",
            .job_status = "JobStatus",
            .message = "Message",
            .submit_time = "SubmitTime",
            .end_time = "EndTime",
            .document_classifier_arn = "DocumentClassifierArn",
            .input_data_config = "InputDataConfig",
            .output_data_config = "OutputDataConfig",
            .data_access_role_arn = "DataAccessRoleArn",
            .volume_kms_key_id = "VolumeKmsKeyId",
            .vpc_config = "VpcConfig",
        };
        return @field(mappings, field_name);
    }
};

pub const SyntaxToken = struct {
    token_id: ?i64 = null,
    text: ?[]const u8 = null,
    begin_offset: ?i64 = null,
    end_offset: ?i64 = null,
    part_of_speech: ?PartOfSpeechTag = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .token_id = "TokenId",
            .text = "Text",
            .begin_offset = "BeginOffset",
            .end_offset = "EndOffset",
            .part_of_speech = "PartOfSpeech",
        };
        return @field(mappings, field_name);
    }
};

pub const PartOfSpeechTag = struct {
    tag: ?[]const u8 = null,
    score: ?f32 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .tag = "Tag",
            .score = "Score",
        };
        return @field(mappings, field_name);
    }
};

pub const SentimentScore = struct {
    positive: ?f32 = null,
    negative: ?f32 = null,
    neutral: ?f32 = null,
    mixed: ?f32 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .positive = "Positive",
            .negative = "Negative",
            .neutral = "Neutral",
            .mixed = "Mixed",
        };
        return @field(mappings, field_name);
    }
};

pub const KeyPhrase = struct {
    score: ?f32 = null,
    text: ?[]const u8 = null,
    begin_offset: ?i64 = null,
    end_offset: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .score = "Score",
            .text = "Text",
            .begin_offset = "BeginOffset",
            .end_offset = "EndOffset",
        };
        return @field(mappings, field_name);
    }
};

pub const Entity = struct {
    score: ?f32 = null,
    type: ?[]const u8 = null,
    text: ?[]const u8 = null,
    begin_offset: ?i64 = null,
    end_offset: ?i64 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .score = "Score",
            .type = "Type",
            .text = "Text",
            .begin_offset = "BeginOffset",
            .end_offset = "EndOffset",
        };
        return @field(mappings, field_name);
    }
};

pub const DominantLanguage = struct {
    language_code: ?[]const u8 = null,
    score: ?f32 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .language_code = "LanguageCode",
            .score = "Score",
        };
        return @field(mappings, field_name);
    }
};

pub const BatchItemError = struct {
    index: ?i64 = null,
    error_code: ?[]const u8 = null,
    error_message: ?[]const u8 = null,

    pub fn fieldNameFor(_: @This(), comptime field_name: []const u8) []const u8 {
        const mappings = .{
            .index = "Index",
            .error_code = "ErrorCode",
            .error_message = "ErrorMessage",
        };
        return @field(mappings, field_name);
    }
};
